#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <regex.h>
#include "../swstring.h"
#include "../cvecheck_common.h"
#include "../output/stringscmd.h"

/*
 * Copyright 2010 Sven Vermeulen.
 * Subject to the GNU Public License, version 3.
 */
 
// dbimpl_initialize_workstate - Initialize the workstate variable
void dbimpl_initialize_workstate(struct workstate * ws);

// dbimpl_load_databases - Load the databases into the workstate
int dbimpl_load_databases(struct workstate * ws);

// dbimpl_clear_versiondatabase - Clear the version database
void dbimpl_clear_versiondatabase(struct workstate * ws);

// dbimpl_clear_versiondata - Clear the version gathering data
void dbimpl_clear_versiondata(struct workstate * ws);

// dbimpl_process_binary - Process the binary file as mentioned in the workstate 
int dbimpl_process_binary(struct workstate * ws);

// dbimpl_verify_installed_versus_cve - Match installed software against known CVEs
void dbimpl_verify_installed_versus_cve(struct workstate * ws);

// dbimpl_initialize_arguments - Initialize arguments structure
void dbimpl_initialize_arguments(struct arguments * arg);

// dbimpl_store_cve_in_db_init - Initialize CVE entry
void dbimpl_store_cve_in_db_init(struct workstate * ws);

// dbimpl_store_cve_in_db_exit - Finalize CVE entry
void dbimpl_store_cve_in_db_exit(struct workstate * ws);

// dbimpl_store_cve_in_db - Add the selected CVE into the database
int dbimpl_store_cve_in_db(struct workstate * ws, char * cveId, char * cpeId);

// dbimpl_add_versiongather - Add a versiongather entry into the database
int dbimpl_add_versiongather(struct workstate * ws, struct versiongather_data vg, struct cpe_data cpe);

// dbimpl_initialize_databases - Initialize the database structures
int dbimpl_initialize_databases(struct workstate * ws);

// dbimpl_report_installed - Report on installed software/versions
void dbimpl_report_installed(struct workstate * ws, int showfiles);
